//+------------------------------------------------------------------+
//|                                RSTD_EnhancedlSignal_to_Noise.mq4 |
//|                         Copyright  2005, Luis Guilherme Damiani |
//|                                      http://www.damianifx.com.br |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Luis Guilherme Damiani"
#property link      "http://www.damianifx.com.br"

#property indicator_separate_window
//#property indicator_minimum 10
//#property indicator_maximum 35
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DodgerBlue
#property strict
//---- input parameters
extern int       maxbars=1200;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double I1[];
double Q1[];
double jI[];
double jQ[];
double I2[];
double I3=0;
double Q2[];
double Q3[];
double Re[];
double Im[];
double HDPer[];
double SmoothPer[];
double Noise=0,Noise_old=0;
int arrSize;

int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexBuffer(1,ExtMapBuffer2);
//----   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
  
double Smooth(int price)
   {
      return(iMA(NULL,0,4,0, MODE_LWMA,PRICE_MEDIAN, price));
   }

double Detrender(int pri) 
   {
      if (pri>arrSize-6) return(0);
      double detr= (0.0962*Smooth(pri)+ 0.5769*Smooth(pri+2)- 0.5769*Smooth(pri+4)
      - 0.0962*Smooth(pri+6))* (0.075*HDPer[pri+1]+0.54); 
      return(detr);
   }  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
      int limit;
      int counted_bars=IndicatorCounted();      
   //---- check for possible errors
      if(counted_bars<0) return(-1);
      arrSize = MathMin(maxbars+60,Bars);
   //---- last counted bar will be recounted
      limit=MathMin(Bars-counted_bars,arrSize-7);
      if(limit>1)
      {
         ArrayResize(I1,arrSize);
         ArrayResize( Q1,arrSize);
         ArrayResize( jI,arrSize);
         ArrayResize( jQ,arrSize);
         ArrayResize( I2,arrSize);
         ArrayResize( Q2,arrSize);
         ArrayResize( Q3,arrSize);
         ArrayResize( Re,arrSize);
         ArrayResize( Im,arrSize);
         ArrayResize(HDPer,arrSize);
         ArrayResize(SmoothPer,arrSize);
         Noise=0;     
         Noise_old=0;
         ArrayInitialize(I1,0);
         ArrayInitialize( Q1,0);
         ArrayInitialize( jI,0);
         ArrayInitialize( jQ,0);
         ArrayInitialize( I2,0);
         ArrayInitialize( Q2,0);
         ArrayInitialize( Re,0);
         ArrayInitialize( Im,0);
         ArrayInitialize( Q3,0);
         ArrayInitialize(HDPer,0);
         ArrayInitialize(SmoothPer,0);
         limit=arrSize-7;
      }
//      if (limit>Bars-6 )limit=Bars-6;
//      return(0);
      for(int i=limit; i>=0; i--)
      {
         //HILBERT TRANSFORM BEGIN
         // Compute InPhase and Quadrature components
	      I1[i] = Detrender(i+3);
	      Q1[i] = (0.0962*Detrender(i) + 0.5769*Detrender(i+2) - 0.5769*Detrender(i+4) 
	           - 0.0962*Detrender(i+6)) * (0.075*HDPer[i+1] + 0.54); 
         //HILBERT TRANSFORM END

         // Advance the phase of I1 and Q1 by 90 degrees
	      jI[i] = (0.0962*I1[i] + 0.5769*I1[i+2] - 0.5769*I1[i+4] - 0.0962*I1[i+6])*(0.075*HDPer[i+1] + 0.54);
	      jQ[i] = (0.0962*Q1[i] + 0.5769*Q1[i+2] - 0.5769*Q1[i+4] - 0.0962*Q1[i+6])*(0.075*HDPer[i+1] + 0.54);

         // Phasor addition for 3 bar averaging
	      I2[i] = I1[i] - jQ[i];
	      Q2[i] = Q1[i] + jI[i];

         // Smooth the I and Q components before applying the discriminator
	      I2[i] = 0.2*I2[i] + 0.8*I2[i+1];
	      Q2[i] = 0.2*Q2[i] + 0.8*Q2[i+1];

         // Homodyne Discriminator
         double HomoDis=0;
	      Re[i] = I2[i]*I2[i+1] + Q2[i]*Q2[i+1];
	      Im[i] = I2[i]*Q2[i+1] - Q2[i]*I2[i+1];
	      Re[i] = 0.2*Re[i] + 0.8*Re[i+1];
	      Im[i] = 0.2*Im[i] + 0.8*Im[i+1];
	      if (Im[i] != 0 && Re[i] != 0)HomoDis= 6.2832 / MathArctan(Im[i]/Re[i]);
   	   if (HomoDis > 1.5*HDPer[i+1])HomoDis = 1.5*HDPer[i+1];
	      if (HomoDis < 0.67*HDPer[i+1])HomoDis = 0.67*HDPer[i+1];
	      if (HomoDis < 6)HomoDis = 6.0;
	      if (HomoDis > 50)HomoDis = 50.0;
      	HomoDis = 0.2*HomoDis + 0.8*HDPer[i+1];
	      HDPer[i]=HomoDis;
	      SmoothPer[i] = 0.33*HomoDis + 0.67*SmoothPer[i+1];
	   
	      //S-to-N calculations  
	      Q3[i]=0.5*(Smooth(i)-Smooth(i+2))*(0.1759*SmoothPer[i]+0.4607);
	      I3=0;
	      for(int cnt=0;cnt<MathFloor(SmoothPer[i]/2);cnt++)
	        I3=I3+Q3[cnt];
           if (MathFloor(SmoothPer[i]/2)!=0)
	            I3=1.57*I3/MathFloor(SmoothPer[i]/2);
	      double Signal=I3*I3+Q3[i]*Q3[i];
	      Noise= 0.1*(High[i]-Low[i])*(High[i]-Low[i])*0.25+0.9*Noise_old;
	      if(i>0) Noise_old=Noise;	      
	      if(Noise!=0 && Signal !=0) ExtMapBuffer1[i]=
	      0.33*(10*MathLog(Signal/Noise)/MathLog(10))+0.67*ExtMapBuffer1[i+1];
       }      
   //----
      SetIndexDrawBegin(0,Bars-arrSize+60);
      return(0);
  }
//+------------------------------------------------------------------+